jQuery(document).ready(function(){
    // If we are in the widgets page, init our tabs and bind our actions
    
    if(typeof wpWidgets != 'undefined') {   
        sectionWidgetCreateTabs(jQuery('div.section-widget-tabs-container'));
             
        /*
            Things are getting a bit complicated here. When you add a widget to the sidebar, wordpress actually
            copies the HTML from a "template" (or "placeholder") and inject it to the sidebar. In the template
            the ids are like "section-widget-some-div-___i___" and obviously this ___i___ will be replaced by
            the actual widget id when it's being copied to the sidebar. This id change breaks the way jQuery
            handle the tabs switching actions. So we have to rebind those actions. Unfortunately, there is no
            "hooks" or anything that we could hook into during this process. I could have binded the code to the
            widget-action click event, but wordpress' own JS hook returns false which stopped the event from
            bubbling, so I had to hack into the internals and add the code by aliasing one of their methods...
            UGLY. And this is probably going to break in the future. But I think this is the best way to do it
            for now... so... (check out /wp-admin/js/widgets.dev.js)
        */
        
        // Rename their addEvents method (good thing JS is not multi-threaded...)
        wpWidgets.__wp_original__addEvents__sw201__ = wpWidgets.addEvents;
        
        // Overwrite it by our own code
        wpWidgets.addEvents = function(sc) {
            // sc is the scope
            sc = sc || document;
            if(sc != document)
                sectionWidgetCreateTabs(jQuery('div.section-widget-tabs-container', sc));
            
            // Call the original
            wpWidgets.__wp_original__addEvents__sw201__(sc);
        };
        
        sectionWidgetLoaded = true;
    }
});

function sectionWidgetCreateTabs(elements){
    console.log(elements.length);
    jQuery(elements).each(function(i,e){
        e = jQuery(e);
        
        e.tabs();
        
        // Find all parents...
        jQuery('div.section-widget-tab-panel li:has(ul.children)>div.section-widget-checklist-entry',e).each(function(i,e) {
            e = jQuery(e);
            
            // Add the expand/collapse + select/deselect controls
            e.not('*:has(span.section-widget-controls-container)') // You do not want to add the controls twice
                .append(' <span class="section-widget-controls-container"><a href="#" class="section-widget-controls-collapse">Collapse</a> | <a href="#" class="section-widget-controls-select">Select All</a></span>')
                .end()
             .hover(
                 function(){
                     jQuery(this).children('span.section-widget-controls-container').show();
                 },
                 
                 function(){
                     jQuery(this).children('span.section-widget-controls-container').hide();
                 }
             );
        });
        
        // ...and bind the actions
        jQuery('.section-widget-controls-collapse',e).bind('click', sectionWidgetCollapse);
        jQuery('.section-widget-controls-select',e).bind('click', sectionWidgetSelect);
    });
}

// Actions for the contorls...

function sectionWidgetCollapse(e){
    e = jQuery(e.target);
    e.parent().parent().siblings('ul.children').hide(); // There must be a better way...
    e.removeClass('section-widget-controls-collapse')
     .addClass('section-widget-controls-expand')
     .unbind('click')
     .bind('click',sectionWidgetExpand)
     .text('Expand');
    return false;
}

function sectionWidgetExpand(e){
    e = jQuery(e.target);
    e.parent().parent().siblings('ul.children').show(); // There must be a better way...
    e.removeClass('section-widget-controls-expand')
     .addClass('section-widget-controls-collapse')
     .unbind('click')
     .bind('click',sectionWidgetCollapse)
     .text('Collapse');
    return false;
}

function sectionWidgetSelect(e){
    e = jQuery(e.target);
    e.parent().parent().parent().find('input:checkbox') // There must be a better way...
        .each(function(){
            this.checked = true;
        });
    e.removeClass('section-widget-controls-select')
     .addClass('section-widget-controls-deselect')
     .unbind('click')
     .bind('click',sectionWidgetDeselect)
     .text('Deselect All');
    return false;
}

function sectionWidgetDeselect(e){
    e = jQuery(e.target);
    e.parent().parent().parent().find('input:checkbox') // There must be a better way...
        .each(function(){
            this.checked = false;
        });
    e.removeClass('section-widget-controls-deselect')
     .addClass('section-widget-controls-select')
     .unbind('click')
     .bind('click',sectionWidgetSelect)
     .text('Select All');
    return false;
}
